Attribute VB_Name = "USBAPI"
Option Explicit


Declare Function CreateInstance Lib "ICPDAS_USBIO.dll" () As Long
Declare Sub DisposeInstance Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long)

'SYSTEM
Declare Function OpenDevice Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal wUSBIO_DID As Integer, ByVal byUSBIO_BID As Byte) As Integer

Declare Function CloseDevice Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long) As Integer

Declare Function SYNCDevice Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long) As Integer
Declare Function SetCommTimeout Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_dwCommTimeout As Long) As Integer
Declare Function GetCommTimeout Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwCommTimeout As Long) As Integer

Declare Function SetAutoResetWDT Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_bEnable As Boolean) As Integer


' DEVICE   Lib "ICPDAS_USBIO.dll" (Get)
Declare Function RefreshDeviceInfo Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long) As Integer

Declare Function GetDeviceID Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwDeviceID As Long) As Integer




Declare Function GetSoftWDTTimeout Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwSoftWDTTimeout As Long) As Integer
Declare Function GetFwVer Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_wFwVer As Integer) As Integer


Declare Function GetDeviceNickName Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byDeviceNickName As Byte) As Integer
Declare Function GetDeviceSN Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byDeviceSN As Byte) As Integer
Declare Function GetSupportIOMask Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySupportIOMask As Byte) As Integer
Declare Function GetDITotal Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byDITotal As Byte) As Integer
Declare Function GetDOTotal Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byDOTotal As Byte) As Integer
Declare Function GetAITotal Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byAITotal As Byte) As Integer
Declare Function GetAOTotal Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byAOTotal As Byte) As Integer
Declare Function GetPITotal Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byPITotal As Byte) As Integer
Declare Function GetPOTotal Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byPOTotal As Byte) As Integer

' DEVICE   Lib "ICPDAS_USBIO.dll" (Set)
Declare Function SetUserDefinedBoardID Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, i_byBID As Byte) As Integer
Declare Function SetDeviceNickName Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byDeviceNickName As Byte) As Integer
Declare Function SetSoftWDTTimeout Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, i_dwSoftWDTTimeout As Long) As Integer
Declare Function LoadDefault Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long) As Integer

' CALLBACK REGISTRATION
'Declare Function  RegisterEmergencyPktEventHandle  Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long,OnEmergencyPktArriveEvent i_evtHandle)as Integer
' Get DO configuration and data
Declare Function DO_GetPowerOnEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byPowerOnEnable As Byte) As Integer
Declare Function DO_GetSafetyEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySafetyEnable As Byte) As Integer
Declare Function DO_GetSafetyValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySafetyValue As Byte) As Integer
Declare Function DO_GetDigitalOutputInverse Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwInverse As Long) As Integer
Declare Function DO_ReadValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byDOValue As Byte) As Integer
' Set DO configuration and data
Declare Function DO_SetPowerOnEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_byPowerOnEnable As Byte) As Integer
Declare Function DO_SetPowerOnEnables Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byPowerOnEnables As Byte) As Integer
Declare Function DO_SetSafetyEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_bySafetyEnable As Byte) As Integer
Declare Function DO_SetSafetyValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_bySafetyValue As Byte) As Integer
Declare Function DO_SetDigitalOutputInverse Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_dwInverse As Long) As Integer
Declare Function DO_WriteValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byDOValue As Byte) As Integer
Declare Function DO_WriteChannelValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChannel As Byte, ByVal i_byValue As Byte) As Integer

' Get DI configuration and data
Declare Function DI_GetDigitalFilterWidth Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_wFilterWidth As Integer) As Integer
Declare Function DI_GetDigitalValueInverse Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwInverse As Long) As Integer
Declare Function DI_GetCntEdgeTrigger Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwEdgeTrig As Long) As Integer
Declare Function DI_ReadValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byDIValue As Byte) As Integer
Declare Function DI_ReadCounterValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwDICntValue As Long) As Integer
' Set DI configuration and data
Declare Function DI_SetDigitalFilterWidth Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_wFilterWidth As Integer) As Integer
Declare Function DI_SetDigitalValueInverse Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_dwInverse As Long) As Integer
Declare Function DI_SetCntEdgeTrigger Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_dwEdgeTrig As Long) As Integer
Declare Function DI_WriteClearCounter Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToClr As Byte) As Integer
Declare Function DI_WriteClearCounters Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_dwCntClrMask As Long) As Integer

' Get AI configuration and data
Declare Function AI_GetTotalSupportType Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byTotalSupportType As Byte) As Integer
Declare Function AI_GetSupportTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySupportTypeCode As Byte) As Integer
Declare Function AI_GetTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byTypeCode As Byte) As Integer
Declare Function AI_GetChCJCOffset Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fChCJCOffset As Single) As Integer
Declare Function AI_GetChEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byChEnable As Byte) As Integer
Declare Function AI_GetFilterRejection Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byFilterRejection As Byte) As Integer
Declare Function AI_GetCJCOffset Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fCJCOffset As Single) As Integer
Declare Function AI_GetCJCEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byCJCEnable As Byte) As Integer
Declare Function AI_GetWireDetectEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byWireDetectEnable As Byte) As Integer
Declare Function AI_GetResolution Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byResolution As Byte) As Integer
Declare Function AI_ReadValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwAIValue As Long) As Integer
Declare Function AI_ReadValueDigitalWithChSta Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwAIValue As Long, ByRef o_byAIChStatus As Byte) As Integer
Declare Function AI_ReadValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fAIValue As Single) As Integer
Declare Function AI_ReadValueAnalogWithChSta Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fAIValue As Single, ByRef o_byAIChStatus As Byte) As Integer

Declare Function AI_ReadCJCValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fCJCValue As Single) As Integer
Declare Function AI_GetChSampleRate Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_dwSampleRate As Long) As Integer


' Set AI configuration
Declare Function AI_SetTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_byTypeCode As Byte) As Integer
Declare Function AI_SetTypeCodes Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byTypeCodes As Byte) As Integer
Declare Function AI_SetChCJCOffset Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_fChCJCOffset As Single) As Integer
Declare Function AI_SetChCJCOffsets Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_fChCJCOffsets As Single) As Integer
Declare Function AI_SetChEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byChEnable As Byte) As Integer
Declare Function AI_SetDataFormat Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byDataFormat As Byte) As Integer
Declare Function AI_SetFilterRejection Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byFilterRejection As Byte) As Integer
Declare Function AI_SetCJCOffset Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_fCJCOffset As Single) As Integer
Declare Function AI_SetCJCEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byCJCEnable As Byte) As Integer
Declare Function AI_SetWireDetectEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byWireDetectEnable As Byte) As Integer
Declare Function AI_SetChSampleRate Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_dwSampleRate As Long) As Integer
' Get AO configuration and data
Declare Function AO_GetTotalSupportType Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byTotalSupportType As Byte) As Integer
Declare Function AO_GetSupportTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySupportTypeCode As Byte) As Integer
Declare Function AO_GetTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byTypeCode As Byte) As Integer
Declare Function AO_GetChEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byChEnable As Byte) As Integer
Declare Function AO_GetResolution Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byResolution As Byte) As Integer
Declare Function AO_ReadExpValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwAOExpValue As Long) As Integer
Declare Function AO_ReadExpValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fAOExpValue As Single) As Integer
Declare Function AO_ReadCurValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwAOCurValue As Long) As Integer
Declare Function AO_ReadCurValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fAOCurValue As Single) As Integer
Declare Function AO_GetPowerOnEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byPowerOnEnable As Byte) As Integer
Declare Function AO_GetSafetyEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySafetyEnable As Byte) As Integer
Declare Function AO_GetPowerOnValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwPwrOnValue As Long) As Integer
Declare Function AO_GetPowerOnValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fPwrOnValue As Single) As Integer
Declare Function AO_GetSafetyValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwSafetyValue As Long) As Integer
Declare Function AO_GetSafetyValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fSafetyValue As Single) As Integer
Declare Function AO_GetSlewRate Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySlewRate As Byte) As Integer
' Set AO configuration and data
Declare Function AO_SetTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_byTypeCode As Byte) As Integer
Declare Function AO_SetTypeCodes Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byTypeCodes As Byte) As Integer
Declare Function AO_SetChEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byChEnable As Byte) As Integer
Declare Function AO_WriteChannelValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_dwAOVal As Long) As Integer
Declare Function AO_WriteValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_dwAOValue As Long) As Integer
                                
Declare Function AO_WriteChannelValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_fAOExpValue As Single) As Integer
Declare Function AO_WriteValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_fAOExpValue As Single) As Integer
Declare Function AO_SetPowerOnEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byPowerOnEnable As Byte) As Integer
Declare Function AO_SetSafetyEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_bySafetyEnable As Byte) As Integer
Declare Function AO_SetPowerOnValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_dwPwrOnValue As Long) As Integer
Declare Function AO_SetPowerOnChannelValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, i_dwPwrOnValue As Long) As Integer
Declare Function AO_SetPowerOnValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_fPwrOnValue As Single) As Integer
Declare Function AO_SetPowerOnChannelValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_fPwrOnValue As Single) As Integer
Declare Function AO_SetSafetyValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_dwSafetyValue As Long) As Integer
Declare Function AO_SetSafetyChannelValueDigital Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_dwSafetyValue As Long) As Integer
Declare Function AO_SetSafetyValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_fSafetyValue As Single) As Integer
Declare Function AO_SetSafetyChannelValueAnalog Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_fSafetyValue As Single) As Integer
Declare Function AO_SetSlewRate Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_bySlewRate As Byte) As Integer

' Get PI configuration and data
Declare Function PI_GetTotalSupportType Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byTotalSupportType As Byte) As Integer
Declare Function PI_GetSupportTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_bySupportTypeCode As Byte) As Integer
Declare Function PI_GetTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byTypeCode As Byte) As Integer
Declare Function PI_GetTriggerMode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byTriggerMode As Byte) As Integer
Declare Function PI_GetChIsolatedFlag Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byChIsolatedFlag As Byte) As Integer
Declare Function PI_GetLPFilterEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_byLPFilterEnable As Byte) As Integer
Declare Function PI_GetLPFilterWidth Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_wLPFilterWidth As Integer) As Integer
Declare Function PI_ReadValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwCntValue As Long, ByRef o_byChStatus As Byte) As Integer
Declare Function PI_ReadCntValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_dwCntValue As Long, ByRef o_byChStatus As Byte) As Integer
Declare Function PI_ReadFreqValue Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef o_fFreqValue As Single, ByRef o_byChStatus As Byte) As Integer
' Set PI configuration
Declare Function PI_SetTypeCode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_byTypeCode As Byte) As Integer
Declare Function PI_SetTypeCodes Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byTypeCodes As Byte) As Integer
Declare Function PI_ClearSingleChCount Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToClr As Byte) As Integer
Declare Function PI_ClearChCount Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byClrMask As Byte) As Integer
Declare Function PI_ClearSingleChStatus Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToClr As Byte) As Integer
Declare Function PI_ClearChStatus Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byClrMask As Byte) As Integer

'int __stdcall PI_ClearAllChCount  Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long)as Integer
Declare Function PI_SetTriggerMode Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_byTriggerMode As Byte) As Integer
Declare Function PI_SetTriggerModes Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byTriggerModes As Byte) As Integer
Declare Function PI_SetChIsolatedFlag Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_bChIsolatedFlag As Boolean) As Integer
Declare Function PI_SetChIsolatedFlags Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byChIsolatedFlag As Byte) As Integer
Declare Function PI_SetLPFilterEnable Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_bLPFilterEnable As Boolean) As Integer
Declare Function PI_SetLPFilterEnables Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_byLPFilterEnables As Byte) As Integer
Declare Function PI_SetLPFilterWidth Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByVal i_byChToSet As Byte, ByVal i_wLPFilterWidth As Integer) As Integer
Declare Function PI_SetLPFilterWidths Lib "ICPDAS_USBIO.dll" (ByVal hUSB As Long, ByRef i_wLPFilterWidths As Integer) As Integer
