VERSION 5.00
Begin VB.Form frmUSBIO 
   Caption         =   "Form1"
   ClientHeight    =   6705
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   11940
   LinkTopic       =   "Form1"
   ScaleHeight     =   6705
   ScaleWidth      =   11940
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   5280
      Top             =   6240
   End
   Begin VB.CommandButton btnWriteAO 
      Caption         =   "Write"
      Height          =   255
      Left            =   10440
      TabIndex        =   15
      Top             =   2640
      Width           =   1095
   End
   Begin VB.CommandButton btnWriteDOBit 
      Caption         =   "Write"
      Height          =   255
      Left            =   10560
      TabIndex        =   14
      Top             =   1680
      Width           =   855
   End
   Begin VB.TextBox txtAOVal 
      Height          =   285
      Left            =   9120
      TabIndex        =   13
      Text            =   "5"
      Top             =   2640
      Width           =   1215
   End
   Begin VB.ComboBox cboAOCh 
      Height          =   315
      Left            =   7560
      TabIndex        =   12
      Text            =   "Combo4"
      Top             =   2640
      Width           =   1215
   End
   Begin VB.ComboBox cboBitVal 
      Height          =   315
      ItemData        =   "frmUSBIO.frx":0000
      Left            =   9120
      List            =   "frmUSBIO.frx":000A
      TabIndex        =   11
      Text            =   "Combo3"
      Top             =   1680
      Width           =   1215
   End
   Begin VB.ComboBox cboDOCh 
      Height          =   315
      Left            =   7560
      TabIndex        =   10
      Text            =   "Combo2"
      Top             =   1680
      Width           =   1095
   End
   Begin VB.TextBox txtBoardID 
      Height          =   375
      Left            =   4080
      TabIndex        =   6
      Text            =   "1"
      Top             =   600
      Width           =   1335
   End
   Begin VB.ComboBox cboDeviceID 
      Height          =   315
      ItemData        =   "frmUSBIO.frx":0014
      Left            =   2160
      List            =   "frmUSBIO.frx":002A
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   600
      Width           =   1695
   End
   Begin VB.ListBox lstData 
      Height          =   4155
      Left            =   2520
      TabIndex        =   2
      Top             =   1560
      Width           =   3375
   End
   Begin VB.ListBox lstMsg 
      Height          =   4155
      Left            =   360
      TabIndex        =   1
      Top             =   1560
      Width           =   2055
   End
   Begin VB.CommandButton cmdOpenDevice 
      Caption         =   "Open Device"
      Height          =   375
      Left            =   360
      TabIndex        =   0
      Top             =   480
      Width           =   1575
   End
   Begin VB.Label Label6 
      Caption         =   "I/O Data List"
      Height          =   255
      Left            =   2640
      TabIndex        =   17
      Top             =   1200
      Width           =   3255
   End
   Begin VB.Label Label3 
      Caption         =   "Descriptions"
      Height          =   255
      Left            =   480
      TabIndex        =   16
      Top             =   1200
      Width           =   1935
   End
   Begin VB.Label Label5 
      Caption         =   "Write AO Value"
      Height          =   255
      Left            =   6120
      TabIndex        =   9
      Top             =   2760
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Write DO Bit"
      Height          =   375
      Left            =   6120
      TabIndex        =   8
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label lbStatus 
      Caption         =   "Open Status"
      Height          =   375
      Left            =   5880
      TabIndex        =   7
      Top             =   600
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Board ID"
      Height          =   255
      Left            =   4200
      TabIndex        =   5
      Top             =   240
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Select USB ID"
      Height          =   255
      Left            =   2160
      TabIndex        =   4
      Top             =   240
      Width           =   1695
   End
End
Attribute VB_Name = "frmUSBIO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


Option Explicit

Dim hUSB As Long
Dim deviceID As Integer
Dim usbIO() As Integer
Dim usbDeviceID As Integer
Dim m_byDITotal As Byte
Dim m_byDOTotal As Byte
Dim m_byAITotal As Byte
Dim m_byAOTotal As Byte
Dim m_byPITotal As Byte
Dim m_byPOTotal As Byte

Const USBIO_MINPID = &H400
Const BiggerBoard = &H100
Const USB2019 = (USBIO_MINPID + 19)
Const USB2026 = (USBIO_MINPID + 26)
Const USB2045 = (USBIO_MINPID + 45)
Const USB2051 = (USBIO_MINPID + 51)
Const USB2055 = (USBIO_MINPID + 55)
Const USB2060 = (USBIO_MINPID + 60)
Const USB2064 = (USBIO_MINPID + 64)
Const USB2084 = (USBIO_MINPID + 84)
Const USB2055_32 = (USBIO_MINPID + BiggerBoard)
Const USB2068_18 = (USBIO_MINPID + BiggerBoard + 1)
Const USB2045_32 = (USBIO_MINPID + BiggerBoard + 2)
Const USB2051_32 = (USBIO_MINPID + BiggerBoard + 3)
Const USB2060_24 = (USBIO_MINPID + BiggerBoard + 4)
Const USB2064_16 = (USBIO_MINPID + BiggerBoard + 5)
Const USB2069_18 = (USBIO_MINPID + BiggerBoard + 6)

Private Sub btnWriteAO_Click()
Dim ch As Integer
Dim fVal As Single
Dim ret As Integer
    ch = cboAOCh.ListIndex
    ret = AO_WriteChannelValueAnalog(hUSB, ch, Val(txtAOVal.Text))
    UpdateIO
End Sub

Private Sub btnWriteDOBit_Click()
Dim ch As Integer
Dim bitVal As Integer
Dim ret As Integer
    ch = cboDOCh.ListIndex
    bitVal = cboBitVal.ListIndex
    ret = DO_WriteChannelValue(hUSB, ch, bitVal)
    UpdateIO
End Sub

Private Sub cmdOpenDevice_Click()
Dim ret As Integer
Dim iErrCode As Integer

Dim i As Integer
Dim SUPPORT_DI As Integer
Dim SUPPORT_DO As Integer
Dim SUPPORT_AI As Integer
Dim SUPPORT_AO As Integer
Dim SUPPORT_PI As Integer
Dim SUPPORT_PO As Integer
Dim dwSoftWDTTimeout As Long
Dim wFWVer As Integer
Dim bySupIOMask As Byte
Dim byDeviceNickName(0 To 31) As Byte
Dim byDeviceSN(0 To 31) As Byte
         
    deviceID = usbIO(cboDeviceID.ListIndex)
    iErrCode = OpenDevice(hUSB, deviceID, Val(txtBoardID.Text))
    If iErrCode = 0 Then
        
       lbStatus.Caption = "Open Device OK"
       ret = GetSoftWDTTimeout(hUSB, dwSoftWDTTimeout)

       lstMsg.AddItem ("SoftWDT: " + Str(dwSoftWDTTimeout))

       ret = GetFwVer(hUSB, wFWVer)

       lstMsg.AddItem ("Version: " + Hex(wFWVer))
       ret = GetSupportIOMask(hUSB, bySupIOMask)

       lstMsg.AddItem ("Support IO Mask:  0x" + HexFormat(bySupIOMask, 2))

       SUPPORT_DO = bySupIOMask And &H1
       SUPPORT_DI = bySupIOMask And &H2
       SUPPORT_AO = bySupIOMask And &H4
       SUPPORT_AI = bySupIOMask And &H8
       SUPPORT_PO = bySupIOMask And &H10
       SUPPORT_PI = bySupIOMask And &H20
    
       If (SUPPORT_DI > 0) Then
       
            ret = GetDITotal(hUSB, m_byDITotal)
            lstMsg.AddItem ("DI channels: " + Str(m_byDITotal))
       End If
    
       If (SUPPORT_DO > 0) Then
       
            ret = GetDOTotal(hUSB, m_byDOTotal)
            lstMsg.AddItem ("DO channels: " + Str(m_byDOTotal))
            cboDOCh.Clear
            If (m_byDOTotal > 0) Then
            
                 For i = 0 To m_byDOTotal - 1
                
                         cboDOCh.AddItem (Str(i))
                 Next i
                 cboDOCh.ListIndex = 0
                 cboBitVal.ListIndex = 0
            End If
       End If

       If (SUPPORT_AI > 0) Then
       
            ret = GetAITotal(hUSB, m_byAITotal)
            lstMsg.AddItem ("AI channels: " + Str(m_byAITotal))
       End If

       If (SUPPORT_AO > 0) Then
       
            ret = GetAOTotal(hUSB, m_byAOTotal)
            lstMsg.AddItem ("AO channels: " + Str(m_byAOTotal))
            cboAOCh.Clear
            If (m_byAOTotal > 0) Then
            
                 For i = 0 To m_byAOTotal - 1
                
                         cboAOCh.AddItem (Str(i))
                 Next i
                 cboAOCh.ListIndex = 0
            End If
       End If

        If (SUPPORT_PI > 0) Then
        
            ret = GetPITotal(hUSB, m_byPITotal)
            lstMsg.AddItem ("PI channels: " + Str(m_byPITotal))
        End If
    
        If (SUPPORT_PO > 0) Then
        
            ret = GetPOTotal(hUSB, m_byPOTotal)
            lstMsg.AddItem ("PO channels: " + Str(m_byPOTotal))
        End If
               
        Timer1.Enabled = True
        Timer1.Interval = 100
    Else
        Timer1.Enabled = False
        lbStatus.Caption = "OpenDevice error " + Str(iErrCode)
        CloseDevice hUSB
    End If
    
    
    
End Sub

Private Sub Form_Load()
    
    ReDim usbIO(6) As Integer
    
    
   usbIO(0) = USB2019
   usbIO(1) = USB2026
   usbIO(2) = USB2045
   usbIO(3) = USB2051
   usbIO(4) = USB2045_32
   usbIO(5) = USB2051_32
   hUSB = CreateInstance()
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Timer1.Enabled = False
    CloseDevice (hUSB)
End Sub

Private Sub Timer1_Timer()
    UpdateIO
End Sub

Private Sub UpdateIO()
Dim diBytes(0 To 3) As Byte
Dim doBytes(0 To 3) As Byte

Dim iErrCode As Integer
Dim i As Integer
Dim aiVals() As Single
Dim aoVals() As Single
Dim ch As Integer

        ReDim aiVals(m_byAITotal)
        ReDim aoVals(m_byAOTotal)

        
            lstData.Clear
            If m_byDITotal > 0 Then
            
                iErrCode = DI_ReadValue(hUSB, diBytes(0))
                lstData.AddItem ("DI Err =" + Hex(iErrCode) + "  DI HexData = " + HexFormat(diBytes(3), 2) + HexFormat(diBytes(2), 2) + HexFormat(diBytes(1), 2) + HexFormat(diBytes(0), 2))
                lstData.AddItem ("------------------------------")
            End If
            If m_byDOTotal > 0 Then
            
                iErrCode = DO_ReadValue(hUSB, doBytes(0))
                lstData.AddItem ("DO Err =" + Hex(iErrCode) + "  DO HexData = " + HexFormat(doBytes(3), 2) + HexFormat(doBytes(2), 2) + HexFormat(doBytes(1), 2) + HexFormat(doBytes(0), 2))
                lstData.AddItem ("------------------------------")
            End If
            If (m_byAITotal > 0) Then
            
                iErrCode = AI_ReadValueAnalog(hUSB, aiVals(0))
                For ch = 0 To m_byAITotal - 1
                

                    lstData.AddItem ("AI Err=" + Hex(iErrCode) + "  CH(" + Str(ch) + ") = " + Str(aiVals(ch)))
                Next ch
                
                lstData.AddItem ("------------------------------")
            End If

    
            If (m_byAOTotal > 0) Then
            
                iErrCode = AO_ReadCurValueAnalog(hUSB, aoVals(0))
                For ch = 0 To m_byAOTotal - 1
                
    
                    lstData.AddItem ("AO Err=" + Hex(iErrCode) + "  CH(" + Str(ch) + ") = " + Str(aoVals(ch)))
                Next ch
                
    
                lstData.AddItem ("------------------------------")
            End If

       
End Sub

Private Function HexFormat(ByVal data As Long, ByVal Length As Integer) As String
Dim formatStr As String
    formatStr = Right("0000000" + Hex(data), Length)
    HexFormat = formatStr
End Function

